#ifndef _INC_CHUNK
#define _INC_CHUNK


#include <limits.h>
#include <stdio.h>


#ifdef __cplusplus
extern "C" {
#endif


typedef unsigned char BYTE;		/* 8ӥåʤ */
typedef unsigned short WORD;	/* 16ӥåʤ */
typedef short SHORT;			/* 16ӥåդ */
#if !defined(SIZEOF_UNSIGNED_LONG)\
						|| SIZEOF_UNSIGNED_LONG==4 || SIZEOF_UNSIGNED_LONG==0
typedef unsigned long DWORD;	/* 32ӥåʤ */
#else
typedef unsigned int DWORD;
#endif
#if !defined(SIZEOF_LONG) || SIZEOF_LONG==4 || SIZEOF_LONG==0
typedef long LONG;				/* 32ӥåդ */
#else
typedef int LONG;
#endif
typedef DWORD FOURCC;			/* 4ʸ */


typedef struct chunklist {
	long offset;				/* եå */
	FOURCC id;					/* ID */
	DWORD size;					/*  */
	FOURCC form;				/* եॿ */
} CHUNKLIST;
typedef struct chunk {
	int num;					/* ꥹȤο */
	struct chunklist *list;
} CHUNK;


/*	4ĤʸID
	 c1,1ʸ
	 c2,2ʸ
	 c3,3ʸ
	 c4,4ʸ
	RET,ID																	*/
FOURCC make4cc(char c1,char c2,char c3,char c4);


/*	4ĤʸID
	fourcc,ID
	     n,(1..4)
	   RET,ʸ																*/
char getidcc(FOURCC fourcc,int n);


/*	եݥ󥿤󥯹¤Τ
	 fp,եݥ
	RET,󥯹¤														*/
CHUNK *chunkopen(FILE *fp);


/*	󥯹¤Τ
	RET,0:,-1:顼													*/
int chunkfree(CHUNK *ck);


/*	󥯤
	 fp,եݥ
	 ck,󥯹¤
	RET,0:,-1:顼													*/
int chunkin(FILE *fp,CHUNK *ck);


/*	󥯤Ф
	 fp,եݥ
	 ck,󥯹¤
	RET,0:,-1:顼													*/
int chunkout(FILE *fp,CHUNK *ck);


/*	Υ󥯤˰ư
	 fp,եݥ
	 ck,󥯹¤
	RET,0:,-1:顼													*/
int chunknext(FILE *fp,CHUNK *ck);


/*	󥯤ID
	 fp,եݥ
	RET,ID																	*/
FOURCC chunkid(FILE *fp);


/*	󥯤Υ
	 fp,եݥ
	RET,ե															*/
DWORD chunksize(FILE *fp);


/*	󥯤Υե
	 fp,եݥ
	RET,ե															*/
FOURCC chunkform(FILE *fp);


#ifdef __cplusplus
}
#endif
#endif
